
param N, integer;
param v, integer;
set L := {1..N*N};
var x {1..N,1..N,L}, binary;

maximize valeur : v;

subject to un_seil_entier {i in 1..N,j in 1..N} : sum{k in L} x[i,j,k] = 1;
subject to une_seule_fois {k in L} : sum{i in 1..N,j in 1..N} x[i,j,k] = 1;
subject to ligne {i in 1..N} : sum{j in 1..N,k in L} k*x[i,j,k] = v;
subject to colonne {j in 1..N} : sum{i in 1..N,k in L} k*x[i,j,k] = v;
subject to diagp : sum{i in 1..N,k in L} k*x[i,i,k] = v;
subject to diags : sum{i in 1..N,k in L} k*x[N-i+1,i,k] = v;

